Index: src/vector.cpp
===================================================================
--- src/vector.cpp	(revision 6056f1f6a543f7dbfa9dde0b7705d6820addf1c4)
+++ src/vector.cpp	(revision 6cd16bc4b2635b48c1eb855a13b887a00af82259)
@@ -8,9 +8,17 @@
 #include "defs.hpp"
 #include "helpers.hpp"
-#include "memoryallocator.hpp"
+#include "info.hpp"
+#include "gslmatrix.hpp"
 #include "leastsquaremin.hpp"
 #include "log.hpp"
+#include "memoryallocator.hpp"
 #include "vector.hpp"
 #include "verbose.hpp"
+#include "World.hpp"
+
+#include <gsl/gsl_linalg.h>
+#include <gsl/gsl_matrix.h>
+#include <gsl/gsl_permutation.h>
+#include <gsl/gsl_vector.h>
 
 /************************************ Functions for class vector ************************************/
@@ -19,4 +27,22 @@
  */
 Vector::Vector() { x[0] = x[1] = x[2] = 0.; };
+
+/** Constructor of class vector.
+ */
+Vector::Vector(const Vector * const a)
+{
+  x[0] = a->x[0];
+  x[1] = a->x[1];
+  x[2] = a->x[2];
+};
+
+/** Constructor of class vector.
+ */
+Vector::Vector(const Vector &a)
+{
+  x[0] = a.x[0];
+  x[1] = a.x[1];
+  x[2] = a.x[2];
+};
 
 /** Constructor of class vector.
@@ -215,8 +241,9 @@
  * \param *Origin first vector of line
  * \param *LineVector second vector of line
- * \return true -  \a this contains intersection point on return, false - line is parallel to plane
+ * \return true -  \a this contains intersection point on return, false - line is parallel to plane (even if in-plane)
  */
 bool Vector::GetIntersectionWithPlane(const Vector * const PlaneNormal, const Vector * const PlaneOffset, const Vector * const Origin, const Vector * const LineVector)
 {
+  Info FunctionInfo(__func__);
   double factor;
   Vector Direction, helper;
@@ -226,8 +253,9 @@
   Direction.SubtractVector(Origin);
   Direction.Normalize();
-  //Log() << Verbose(4) << "INFO: Direction is " << Direction << "." << endl;
+  DoLog(1) && (Log() << Verbose(1) << "INFO: Direction is " << Direction << "." << endl);
+  //Log() << Verbose(1) << "INFO: PlaneNormal is " << *PlaneNormal << " and PlaneOffset is " << *PlaneOffset << "." << endl;
   factor = Direction.ScalarProduct(PlaneNormal);
-  if (factor < MYEPSILON) { // Uniqueness: line parallel to plane?
-    Log() << Verbose(2) << "WARNING: Line is parallel to plane, no intersection." << endl;
+  if (fabs(factor) < MYEPSILON) { // Uniqueness: line parallel to plane?
+    DoLog(1) && (Log() << Verbose(1) << "BAD: Line is parallel to plane, no intersection." << endl);
     return false;
   }
@@ -235,6 +263,6 @@
   helper.SubtractVector(Origin);
   factor = helper.ScalarProduct(PlaneNormal)/factor;
-  if (factor < MYEPSILON) { // Origin is in-plane
-    //Log() << Verbose(2) << "Origin of line is in-plane, simple." << endl;
+  if (fabs(factor) < MYEPSILON) { // Origin is in-plane
+    DoLog(1) && (Log() << Verbose(1) << "GOOD: Origin of line is in-plane." << endl);
     CopyVector(Origin);
     return true;
@@ -243,5 +271,5 @@
   Direction.Scale(factor);
   CopyVector(Origin);
-  //Log() << Verbose(4) << "INFO: Scaled direction is " << Direction << "." << endl;
+  DoLog(1) && (Log() << Verbose(1) << "INFO: Scaled direction is " << Direction << "." << endl);
   AddVector(&Direction);
 
@@ -250,19 +278,19 @@
   helper.SubtractVector(PlaneOffset);
   if (helper.ScalarProduct(PlaneNormal) < MYEPSILON) {
-    //Log() << Verbose(2) << "INFO: Intersection at " << *this << " is good." << endl;
+    DoLog(1) && (Log() << Verbose(1) << "GOOD: Intersection is " << *this << "." << endl);
     return true;
   } else {
-    Log() << Verbose(2) << "WARNING: Intersection point " << *this << " is not on plane." << endl;
+    DoeLog(2) && (eLog()<< Verbose(2) << "Intersection point " << *this << " is not on plane." << endl);
     return false;
   }
 };
 
-/** Calculates the minimum distance of this vector to the plane.
+/** Calculates the minimum distance vector of this vector to the plane.
  * \param *out output stream for debugging
  * \param *PlaneNormal normal of plane
  * \param *PlaneOffset offset of plane
- * \return distance to plane
- */
-double Vector::DistanceToPlane(const Vector * const PlaneNormal, const Vector * const PlaneOffset) const
+ * \return distance vector onto to plane
+ */
+Vector Vector::GetDistanceVectorToPlane(const Vector * const PlaneNormal, const Vector * const PlaneOffset) const
 {
   Vector temp;
@@ -282,11 +310,23 @@
     sign = 0.;
 
-  return (temp.Norm()*sign);
+  temp.Normalize();
+  temp.Scale(sign);
+  return temp;
+};
+
+/** Calculates the minimum distance of this vector to the plane.
+ * \sa Vector::GetDistanceVectorToPlane()
+ * \param *out output stream for debugging
+ * \param *PlaneNormal normal of plane
+ * \param *PlaneOffset offset of plane
+ * \return distance to plane
+ */
+double Vector::DistanceToPlane(const Vector * const PlaneNormal, const Vector * const PlaneOffset) const
+{
+  return GetDistanceVectorToPlane(PlaneNormal,PlaneOffset).Norm();
 };
 
 /** Calculates the intersection of the two lines that are both on the same plane.
- * We construct auxiliary plane with its vector normal to one line direction and the PlaneNormal, then a vector
- * from the first line's offset onto the plane. Finally, scale by factor is 1/cos(angle(line1,line2..)) = 1/SP(...), and
- * project onto the first line's direction and add its offset.
+ * This is taken from Weisstein, Eric W. "Line-Line Intersection." From MathWorld--A Wolfram Web Resource. http://mathworld.wolfram.com/Line-LineIntersection.html 
  * \param *out output stream for debugging
  * \param *Line1a first vector of first line
@@ -299,80 +339,97 @@
 bool Vector::GetIntersectionOfTwoLinesOnPlane(const Vector * const Line1a, const Vector * const Line1b, const Vector * const Line2a, const Vector * const Line2b, const Vector *PlaneNormal)
 {
-  bool result = true;
-  Vector Direction, OtherDirection;
-  Vector AuxiliaryNormal;
-  Vector Distance;
-  const Vector *Normal = NULL;
-  Vector *ConstructedNormal = NULL;
-  bool FreeNormal = false;
-
-  // construct both direction vectors
-  Zero();
-  Direction.CopyVector(Line1b);
-  Direction.SubtractVector(Line1a);
-  if (Direction.IsZero())
+  Info FunctionInfo(__func__);
+
+  GSLMatrix *M = new GSLMatrix(4,4);
+
+  M->SetAll(1.);
+  for (int i=0;i<3;i++) {
+    M->Set(0, i, Line1a->x[i]);
+    M->Set(1, i, Line1b->x[i]);
+    M->Set(2, i, Line2a->x[i]);
+    M->Set(3, i, Line2b->x[i]);
+  }
+  
+  //Log() << Verbose(1) << "Coefficent matrix is:" << endl;
+  //ostream &output = Log() << Verbose(1);
+  //for (int i=0;i<4;i++) {
+  //  for (int j=0;j<4;j++)
+  //    output << "\t" << M->Get(i,j);
+  //  output << endl;
+  //}
+  if (fabs(M->Determinant()) > MYEPSILON) {
+    DoLog(1) && (Log() << Verbose(1) << "Determinant of coefficient matrix is NOT zero." << endl);
     return false;
-  OtherDirection.CopyVector(Line2b);
-  OtherDirection.SubtractVector(Line2a);
-  if (OtherDirection.IsZero())
+  }
+  DoLog(1) && (Log() << Verbose(1) << "INFO: Line1a = " << *Line1a << ", Line1b = " << *Line1b << ", Line2a = " << *Line2a << ", Line2b = " << *Line2b << "." << endl);
+
+
+  // constuct a,b,c
+  Vector a;
+  Vector b;
+  Vector c;
+  Vector d;
+  a.CopyVector(Line1b);
+  a.SubtractVector(Line1a);
+  b.CopyVector(Line2b);
+  b.SubtractVector(Line2a);
+  c.CopyVector(Line2a);
+  c.SubtractVector(Line1a);
+  d.CopyVector(Line2b);
+  d.SubtractVector(Line1b);
+  DoLog(1) && (Log() << Verbose(1) << "INFO: a = " << a << ", b = " << b << ", c = " << c << "." << endl);
+  if ((a.NormSquared() < MYEPSILON) || (b.NormSquared() < MYEPSILON)) {
+   Zero();
+   DoLog(1) && (Log() << Verbose(1) << "At least one of the lines is ill-defined, i.e. offset equals second vector." << endl);
+   return false;
+  }
+
+  // check for parallelity
+  Vector parallel;
+  double factor = 0.;
+  if (fabs(a.ScalarProduct(&b)*a.ScalarProduct(&b)/a.NormSquared()/b.NormSquared() - 1.) < MYEPSILON) {
+    parallel.CopyVector(Line1a);
+    parallel.SubtractVector(Line2a);
+    factor = parallel.ScalarProduct(&a)/a.Norm();
+    if ((factor >= -MYEPSILON) && (factor - 1. < MYEPSILON)) {
+      CopyVector(Line2a);
+      DoLog(1) && (Log() << Verbose(1) << "Lines conincide." << endl);
+      return true;
+    } else {
+      parallel.CopyVector(Line1a);
+      parallel.SubtractVector(Line2b);
+      factor = parallel.ScalarProduct(&a)/a.Norm();
+      if ((factor >= -MYEPSILON) && (factor - 1. < MYEPSILON)) {
+        CopyVector(Line2b);
+        DoLog(1) && (Log() << Verbose(1) << "Lines conincide." << endl);
+        return true;
+      }
+    }
+    DoLog(1) && (Log() << Verbose(1) << "Lines are parallel." << endl);
+    Zero();
     return false;
-
-  Direction.Normalize();
-  OtherDirection.Normalize();
-
-  //Log() << Verbose(4) << "INFO: Normalized Direction " << Direction << " and OtherDirection " << OtherDirection << "." << endl;
-
-  if (fabs(OtherDirection.ScalarProduct(&Direction) - 1.) < MYEPSILON) { // lines are parallel
-    if ((Line1a == Line2a) || (Line1a == Line2b))
-      CopyVector(Line1a);
-    else if ((Line1b == Line2b) || (Line1b == Line2b))
-        CopyVector(Line1b);
-    else
-      return false;
-    Log() << Verbose(4) << "INFO: Intersection is " << *this << "." << endl;
-    return true;
-  } else {
-    // check whether we have a plane normal vector
-    if (PlaneNormal == NULL) {
-      ConstructedNormal = new Vector;
-      ConstructedNormal->MakeNormalVector(&Direction, &OtherDirection);
-      Normal = ConstructedNormal;
-      FreeNormal = true;
-    } else
-      Normal = PlaneNormal;
-
-    AuxiliaryNormal.MakeNormalVector(&OtherDirection, Normal);
-    //Log() << Verbose(4) << "INFO: PlaneNormal is " << *Normal << " and AuxiliaryNormal " << AuxiliaryNormal << "." << endl;
-
-    Distance.CopyVector(Line2a);
-    Distance.SubtractVector(Line1a);
-    //Log() << Verbose(4) << "INFO: Distance is " << Distance << "." << endl;
-    if (Distance.IsZero()) {
-      // offsets are equal, match found
-      CopyVector(Line1a);
-      result = true;
-    } else {
-      CopyVector(Distance.Projection(&AuxiliaryNormal));
-      //Log() << Verbose(4) << "INFO: Projected Distance is " << *this << "." << endl;
-      double factor = Direction.ScalarProduct(&AuxiliaryNormal);
-      //Log() << Verbose(4) << "INFO: Scaling factor is " << factor << "." << endl;
-      Scale(1./(factor*factor));
-      //Log() << Verbose(4) << "INFO: Scaled Distance is " << *this << "." << endl;
-      CopyVector(Projection(&Direction));
-      //Log() << Verbose(4) << "INFO: Distance, projected into Direction, is " << *this << "." << endl;
-      if (this->IsZero())
-        result = false;
-      else
-        result = true;
-      AddVector(Line1a);
-    }
-
-    if (FreeNormal)
-      delete(ConstructedNormal);
-  }
-  if (result)
-    Log() << Verbose(4) << "INFO: Intersection is " << *this << "." << endl;
-
-  return result;
+  }
+
+  // obtain s
+  double s;
+  Vector temp1, temp2;
+  temp1.CopyVector(&c);
+  temp1.VectorProduct(&b);
+  temp2.CopyVector(&a);
+  temp2.VectorProduct(&b);
+  DoLog(1) && (Log() << Verbose(1) << "INFO: temp1 = " << temp1 << ", temp2 = " << temp2 << "." << endl);
+  if (fabs(temp2.NormSquared()) > MYEPSILON)
+    s = temp1.ScalarProduct(&temp2)/temp2.NormSquared();
+  else
+    s = 0.;
+  DoLog(1) && (Log() << Verbose(1) << "Factor s is " << temp1.ScalarProduct(&temp2) << "/" << temp2.NormSquared() << " = " << s << "." << endl);
+
+  // construct intersection
+  CopyVector(&a);
+  Scale(s);
+  AddVector(Line1a);
+  DoLog(1) && (Log() << Verbose(1) << "Intersection is at " << *this << "." << endl);
+
+  return true;
 };
 
@@ -480,4 +537,17 @@
   else
     return false;
+};
+
+/** Checks whether vector is normal to \a *normal.
+ * @return true - vector is normalized, false - vector is not
+ */
+bool Vector::IsEqualTo(const Vector * const a) const
+{
+  bool status = true;
+  for (int i=0;i<NDIM;i++) {
+    if (fabs(x[i] - a->x[i]) > MYEPSILON)
+      status = false;
+  }
+  return status;
 };
 
@@ -632,11 +702,11 @@
 void Vector::Output() const
 {
-  Log() << Verbose(0) << "(";
+  DoLog(0) && (Log() << Verbose(0) << "(");
   for (int i=0;i<NDIM;i++) {
-    Log() << Verbose(0) << x[i];
+    DoLog(0) && (Log() << Verbose(0) << x[i]);
     if (i != 2)
-      Log() << Verbose(0) << ",";
-  }
-  Log() << Verbose(0) << ")";
+      DoLog(0) && (Log() << Verbose(0) << ",");
+  }
+  DoLog(0) && (Log() << Verbose(0) << ")");
 };
 
@@ -747,5 +817,5 @@
       x[i] = C.x[i];
   } else {
-    eLog() << Verbose(0) << "ERROR: inverse of matrix does not exists: det A = " << detA << "." << endl;
+    DoeLog(1) && (eLog()<< Verbose(1) << "inverse of matrix does not exists: det A = " << detA << "." << endl);
   }
 };
@@ -773,12 +843,12 @@
   projection = ScalarProduct(n)/n->ScalarProduct(n);    // remove constancy from n (keep as logical one)
   // withdraw projected vector twice from original one
-  Log() << Verbose(1) << "Vector: ";
+  DoLog(1) && (Log() << Verbose(1) << "Vector: ");
   Output();
-  Log() << Verbose(0) << "\t";
+  DoLog(0) && (Log() << Verbose(0) << "\t");
   for (int i=NDIM;i--;)
     x[i] -= 2.*projection*n->x[i];
-  Log() << Verbose(0) << "Projected vector: ";
+  DoLog(0) && (Log() << Verbose(0) << "Projected vector: ");
   Output();
-  Log() << Verbose(0) << endl;
+  DoLog(0) && (Log() << Verbose(0) << endl);
 };
 
@@ -799,5 +869,5 @@
   x2.SubtractVector(y2);
   if ((fabs(x1.Norm()) < MYEPSILON) || (fabs(x2.Norm()) < MYEPSILON) || (fabs(x1.Angle(&x2)) < MYEPSILON)) {
-    Log() << Verbose(4) << "WARNING: Given vectors are linear dependent." << endl;
+    DoeLog(2) && (eLog()<< Verbose(2) << "Given vectors are linear dependent." << endl);
     return false;
   }
@@ -833,5 +903,5 @@
   Zero();
   if ((fabs(x1.Norm()) < MYEPSILON) || (fabs(x2.Norm()) < MYEPSILON) || (fabs(x1.Angle(&x2)) < MYEPSILON)) {
-    Log() << Verbose(4) << "WARNING: Given vectors are linear dependent." << endl;
+    DoeLog(2) && (eLog()<< Verbose(2) << "Given vectors are linear dependent." << endl);
     return false;
   }
@@ -884,7 +954,7 @@
   double norm;
 
-  Log() << Verbose(4);
+  DoLog(4) && (Log() << Verbose(4));
   GivenVector->Output();
-  Log() << Verbose(0) << endl;
+  DoLog(0) && (Log() << Verbose(0) << endl);
   for (j=NDIM;j--;)
     Components[j] = -1;
@@ -893,5 +963,5 @@
     if (fabs(GivenVector->x[j]) > MYEPSILON)
       Components[Last++] = j;
-  Log() << Verbose(4) << Last << " Components != 0: (" << Components[0] << "," << Components[1] << "," << Components[2] << ")" << endl;
+  DoLog(4) && (Log() << Verbose(4) << Last << " Components != 0: (" << Components[0] << "," << Components[1] << "," << Components[2] << ")" << endl);
 
   switch(Last) {
@@ -943,7 +1013,7 @@
 
   for (j=0;j<num;j++) {
-    Log() << Verbose(1) << j << "th atom's vector: ";
+    DoLog(1) && (Log() << Verbose(1) << j << "th atom's vector: ");
     (vectors[j])->Output();
-    Log() << Verbose(0) << endl;
+    DoLog(0) && (Log() << Verbose(0) << endl);
   }
 
@@ -1065,5 +1135,5 @@
     j += i+1;
     do {
-      Log() << Verbose(0) << coords[i] << "[0.." << cell_size[j] << "]: ";
+      DoLog(0) && (Log() << Verbose(0) << coords[i] << "[0.." << cell_size[j] << "]: ");
       cin >> x[i];
     } while (((x[i] < 0) || (x[i] >= cell_size[j])) && (check));
@@ -1096,5 +1166,5 @@
   B2 = cos(beta) * x2->Norm() * c;
   C = c * c;
-  Log() << Verbose(2) << "A " << A << "\tB " << B1 << "\tC " << C << endl;
+  DoLog(2) && (Log() << Verbose(2) << "A " << A << "\tB " << B1 << "\tC " << C << endl);
   int flag = 0;
   if (fabs(x1->x[0]) < MYEPSILON) { // check for zero components for the later flipping and back-flipping
@@ -1135,27 +1205,27 @@
   D2 = -y->x[0]/x1->x[0]*x1->x[2]+y->x[2];
   D3 = y->x[0]/x1->x[0]*A-B1;
-  Log() << Verbose(2) << "D1 " << D1 << "\tD2 " << D2 << "\tD3 " << D3 << "\n";
+  DoLog(2) && (Log() << Verbose(2) << "D1 " << D1 << "\tD2 " << D2 << "\tD3 " << D3 << "\n");
   if (fabs(D1) < MYEPSILON) {
-    Log() << Verbose(2) << "D1 == 0!\n";
+    DoLog(2) && (Log() << Verbose(2) << "D1 == 0!\n");
     if (fabs(D2) > MYEPSILON) {
-      Log() << Verbose(3) << "D2 != 0!\n";
+      DoLog(3) && (Log() << Verbose(3) << "D2 != 0!\n");
       x[2] = -D3/D2;
       E1 = A/x1->x[0] + x1->x[2]/x1->x[0]*D3/D2;
       E2 = -x1->x[1]/x1->x[0];
-      Log() << Verbose(3) << "E1 " << E1 << "\tE2 " << E2 << "\n";
+      DoLog(3) && (Log() << Verbose(3) << "E1 " << E1 << "\tE2 " << E2 << "\n");
       F1 = E1*E1 + 1.;
       F2 = -E1*E2;
       F3 = E1*E1 + D3*D3/(D2*D2) - C;
-      Log() << Verbose(3) << "F1 " << F1 << "\tF2 " << F2 << "\tF3 " << F3 << "\n";
+      DoLog(3) && (Log() << Verbose(3) << "F1 " << F1 << "\tF2 " << F2 << "\tF3 " << F3 << "\n");
       if (fabs(F1) < MYEPSILON) {
-        Log() << Verbose(4) << "F1 == 0!\n";
-        Log() << Verbose(4) << "Gleichungssystem linear\n";
+        DoLog(4) && (Log() << Verbose(4) << "F1 == 0!\n");
+        DoLog(4) && (Log() << Verbose(4) << "Gleichungssystem linear\n");
         x[1] = F3/(2.*F2);
       } else {
         p = F2/F1;
         q = p*p - F3/F1;
-        Log() << Verbose(4) << "p " << p << "\tq " << q << endl;
+        DoLog(4) && (Log() << Verbose(4) << "p " << p << "\tq " << q << endl);
         if (q < 0) {
-          Log() << Verbose(4) << "q < 0" << endl;
+          DoLog(4) && (Log() << Verbose(4) << "q < 0" << endl);
           return false;
         }
@@ -1164,5 +1234,5 @@
       x[0] =  A/x1->x[0] - x1->x[1]/x1->x[0]*x[1] + x1->x[2]/x1->x[0]*x[2];
     } else {
-      Log() << Verbose(2) << "Gleichungssystem unterbestimmt\n";
+      DoLog(2) && (Log() << Verbose(2) << "Gleichungssystem unterbestimmt\n");
       return false;
     }
@@ -1170,19 +1240,19 @@
     E1 = A/x1->x[0]+x1->x[1]/x1->x[0]*D3/D1;
     E2 = x1->x[1]/x1->x[0]*D2/D1 - x1->x[2];
-    Log() << Verbose(2) << "E1 " << E1 << "\tE2 " << E2 << "\n";
+    DoLog(2) && (Log() << Verbose(2) << "E1 " << E1 << "\tE2 " << E2 << "\n");
     F1 = E2*E2 + D2*D2/(D1*D1) + 1.;
     F2 = -(E1*E2 + D2*D3/(D1*D1));
     F3 = E1*E1 + D3*D3/(D1*D1) - C;
-    Log() << Verbose(2) << "F1 " << F1 << "\tF2 " << F2 << "\tF3 " << F3 << "\n";
+    DoLog(2) && (Log() << Verbose(2) << "F1 " << F1 << "\tF2 " << F2 << "\tF3 " << F3 << "\n");
     if (fabs(F1) < MYEPSILON) {
-      Log() << Verbose(3) << "F1 == 0!\n";
-      Log() << Verbose(3) << "Gleichungssystem linear\n";
+      DoLog(3) && (Log() << Verbose(3) << "F1 == 0!\n");
+      DoLog(3) && (Log() << Verbose(3) << "Gleichungssystem linear\n");
       x[2] = F3/(2.*F2);
     } else {
       p = F2/F1;
       q = p*p - F3/F1;
-      Log() << Verbose(3) << "p " << p << "\tq " << q << endl;
+      DoLog(3) && (Log() << Verbose(3) << "p " << p << "\tq " << q << endl);
       if (q < 0) {
-        Log() << Verbose(3) << "q < 0" << endl;
+        DoLog(3) && (Log() << Verbose(3) << "q < 0" << endl);
         return false;
       }
@@ -1222,8 +1292,8 @@
     for (j=2;j>=0;j--) {
       k = (i & pot(2,j)) << j;
-      Log() << Verbose(2) << "k " << k << "\tpot(2,j) " << pot(2,j) << endl;
+      DoLog(2) && (Log() << Verbose(2) << "k " << k << "\tpot(2,j) " << pot(2,j) << endl);
       sign[j] = (k == 0) ? 1. : -1.;
     }
-    Log() << Verbose(2) << i << ": sign matrix is " << sign[0] << "\t" << sign[1] << "\t" << sign[2] << "\n";
+    DoLog(2) && (Log() << Verbose(2) << i << ": sign matrix is " << sign[0] << "\t" << sign[1] << "\t" << sign[2] << "\n");
     // apply sign matrix
     for (j=NDIM;j--;)
@@ -1231,5 +1301,5 @@
     // calculate angle and check
     ang = x2->Angle (this);
-    Log() << Verbose(1) << i << "th angle " << ang << "\tbeta " << cos(beta) << " :\t";
+    DoLog(1) && (Log() << Verbose(1) << i << "th angle " << ang << "\tbeta " << cos(beta) << " :\t");
     if (fabs(ang - cos(beta)) < MYEPSILON) {
       break;
Index: src/vector.hpp
===================================================================
--- src/vector.hpp	(revision 6056f1f6a543f7dbfa9dde0b7705d6820addf1c4)
+++ src/vector.hpp	(revision 6cd16bc4b2635b48c1eb855a13b887a00af82259)
@@ -27,4 +27,6 @@
 
   Vector();
+  Vector(const Vector * const a);
+  Vector(const Vector &a);
   Vector(const double x1, const double x2, const double x3);
   ~Vector();
@@ -42,4 +44,5 @@
   bool IsOne() const;
   bool IsNormalTo(const Vector * const normal) const;
+  bool IsEqualTo(const Vector * const a) const;
 
   void AddVector(const Vector * const y);
@@ -66,4 +69,5 @@
   void LinearCombinationOfVectors(const Vector * const x1, const Vector * const x2, const Vector * const x3, const double * const factors);
   double CutsPlaneAt(const Vector * const A, const Vector * const B, const Vector * const C) const;
+  Vector GetDistanceVectorToPlane(const Vector * const PlaneNormal, const Vector * const PlaneOffset) const;
   bool GetIntersectionWithPlane(const Vector * const PlaneNormal, const Vector * const PlaneOffset, const Vector * const Origin, const Vector * const LineVector);
   bool GetIntersectionOfTwoLinesOnPlane(const Vector * const Line1a, const Vector * const Line1b, const Vector * const Line2a, const Vector * const Line2b, const Vector *Normal = NULL);
Index: src/verbose.cpp
===================================================================
--- src/verbose.cpp	(revision 6056f1f6a543f7dbfa9dde0b7705d6820addf1c4)
+++ src/verbose.cpp	(revision 6cd16bc4b2635b48c1eb855a13b887a00af82259)
@@ -1,4 +1,5 @@
 using namespace std;
 
+#include "info.hpp"
 #include "verbose.hpp"
 
@@ -9,5 +10,5 @@
 ostream& Verbose::print (ostream &ost) const
 {
-  for (int i=Verbosity;i--;)
+  for (int i=Verbosity+Info::verbosity;i--;)
     ost.put('\t');
   //Log() << Verbose(0) << "Verbose(.) called." << endl;
@@ -16,5 +17,5 @@
 
 /** States whether current output message should be print or not.
- * Compares Verbose::Verbosity against \a verbosityLevel.
+ * Compares Verbose::Verbosity plus Info::verbosity against \a verbosityLevel.
  * \param verbosityLevel given global level of verbosity
  * \return true - do output, false - don't
@@ -22,7 +23,16 @@
 bool Verbose::DoOutput(int verbosityLevel) const
 {
+  return (verbosityLevel >= Verbosity+Info::verbosity);
+};
+
+/** States whether current error output message should be print or not.
+ * Compares Verbose::Verbosity against \a verbosityLevel.
+ * \param verbosityLevel given global level of verbosity
+ * \return true - do output, false - don't
+ */
+bool Verbose::DoErrorOutput(int verbosityLevel) const
+{
   return (verbosityLevel >= Verbosity);
 };
-
 
 /** Operator for the Verbose(arg) call.
Index: src/verbose.hpp
===================================================================
--- src/verbose.hpp	(revision 6056f1f6a543f7dbfa9dde0b7705d6820addf1c4)
+++ src/verbose.hpp	(revision 6cd16bc4b2635b48c1eb855a13b887a00af82259)
@@ -29,6 +29,13 @@
     Verbose(int value) : Verbosity(value) { }
 
+    // allow access to private variable Verbose::Verbosity
+    friend ostream& operator<<(class errorLogger& l, const Verbose& v);
+    friend ostream& operator<<(class errorLogger* l, const Verbose& v);
+    friend ostream& operator<<(class logger& l, const Verbose& v);
+    friend ostream& operator<<(class logger* l, const Verbose& v);
+
     ostream& print (ostream &ost) const;
     bool DoOutput(int verbosityLevel) const;
+    bool DoErrorOutput(int verbosityLevel) const;
   private:
     int Verbosity;
Index: src/version.h
===================================================================
--- src/version.h	(revision 6cd16bc4b2635b48c1eb855a13b887a00af82259)
+++ src/version.h	(revision 6cd16bc4b2635b48c1eb855a13b887a00af82259)
@@ -0,0 +1,6 @@
+#ifndef VERSION_H_
+#define VERSION_H_
+
+extern const char *ESPACKVersion;
+
+#endif /* VERSION_H_ */
